
//         Ŀ
//              Zlib support for DJGPP version of diskmag Vyhen      
//                         code: ReDox/MovSD (C) 1999                
//         

#include <stdio.h>
#include <stdlib.h>
#include <zlib.h>
#include <io.h>
#include "vyhen.h"

char new_data_logo[]=
"Ŀ\r\n"
"                              -=[ Vyhen #00 ]=-                             \r\n"
"\r\n\r\n";

int gz_create(char *name, long lzh_start)
{

 FILE *fin,*fout;
 gzFile *gzf;
 char *buf,*gz_buf;
 long gz_len,new_pictures_offset,pictures_size;

 puts("  Vytvarim novy format");

 gzf=gzopen("temp_gz.$$$","wb9");
 gzwrite(gzf,text,text_size);
 gzclose(gzf);

 fin=fopen("temp_gz.$$$","rb");
 gz_len=filelength(fileno(fin));
 gz_buf=malloc(gz_len);
 fread(gz_buf,1,gz_len,fin);
 fclose(fin);
 remove("temp_gz.$$$");

 fin=fopen(name,"rb");
 fout=fopen("temp_0.$$$","wb");

 buf=malloc(lzh_start);
 fread(buf,1,lzh_start,fin);

 new_data_logo[123]=vyh_num[0]; // new_data_logo[123]=vyh_num[1];

 new_pictures_offset=pictures_offset>0?lzh_start+gz_len+4:0;

 fwrite(&new_data_logo,1,242,fout);
 fwrite(&new_pictures_offset,4,1,fout);
 fwrite(buf+242+4,1,8000,fout);
 fwrite(&text_size,4,1,fout);
 fwrite(gz_buf,1,gz_len,fout);

 free(buf);
 free(gz_buf);

 if (new_pictures_offset>0) {
    pictures_size=filelength(fileno(fin))-pictures_offset;
    buf=malloc(pictures_size);
    fseek(fin,pictures_offset,SEEK_SET);
    fread(buf,1,pictures_size,fin);
    fwrite(buf,1,pictures_size,fout);
    free(buf);
    }

 fclose(fin);
 fclose(fout);

 remove(name);
 rename("temp_0.$$$",name);

 pictures_offset=new_pictures_offset;

 return 0;
}

int gz_unpack(char *name, long gz_start)
{

 FILE *f;
 gzFile *gzf;

 f=fopen(name,"rb");

 fseek(f,242,SEEK_SET);
 fread(&pictures_offset,4,1,f);

 fseek(f,gz_start,SEEK_SET);
 fread(&text_size,4,1,f);

 fclose(f);

 printf("  Nahravam [%ldkB]\n",text_size/1024);

 text=malloc(text_size);

 f=fopen(name,"rb");
 fseek(f,gz_start+4,SEEK_SET);

 gzf=gzdopen(fileno(f),"rb");
 gzread(gzf,text,text_size);
 gzclose(gzf);

 return 0;
}
